﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;

namespace Erettsegi22_Valasztas
{
    class képviselő
    {
        public int kerület { get; set; }
        public int voksok { get; set; }
        public string név { get; set; }
        public string párt { get; set; }
        public string párt2 { get { return pártok[párt]; } }
        public string párt3 { get { return pártok2[párt]; } }

        private Dictionary<string, string> pártok = new Dictionary<string, string>()
        {
            {"GYEP", "Gyümölcsevők Pártja"},
            {"HEP", "Húsevők Pártja"},
            {"TISZ", "Tejívók Szövetsége"},
            {"ZEP", "Zöldségevők Pártja"},
            {"-","Független jelöltek"}
        };

        private Dictionary<string, string> pártok2 = new Dictionary<string, string>()
        { 
            {"GYEP", "GYEP"},
            {"HEP", "HEP"},
            {"TISZ", "TISZ"},
            {"ZEP", "ZEP" },
            {"-","független"}
        };


        public képviselő(string sor)
        {
            string[] t = sor.Split(' ');
            kerület = int.Parse(t[0]);
            voksok = int.Parse(t[1]);
            név =  t[2] + ' ' + t[3];
            párt = t[4];
        }
    }

    class Valasztas
    {
        static void Main()
        {
            Console.WriteLine("1. feladat: Beolvasás");
            string[] forrás = File.ReadAllLines("szavazatok.txt");
            List<képviselő> képviselők = new List<képviselő>();
            foreach(var i in forrás) képviselők.Add(new képviselő(i));

            Console.WriteLine("2. feldadat: A helyhatósági választáson {0} képviselőjelölt indult!", képviselők.Count);

            Console.Write("3. feldadat: Kérem a képviselő nevét: ");
            string knév=Console.ReadLine();
            var keres = képviselők.Where(x=>x.név==knév);
            if (keres.Count() > 0) Console.WriteLine("\tSzavazatok száma: {0} db", keres.First().voksok);
            else Console.WriteLine("\tIlyen nevű képviselőjelölt nem szerepel a nyilvántartásban!");

            Console.WriteLine("4. feldadat: A választáson {0} állampolgár, a jogosultak {1:P2}-a vett részt.", képviselők.Sum(x=>x.voksok), képviselők.Sum(x=>x.voksok)/12345d );
        
            Console.WriteLine("5. feldadat: Szavazatok aránya");
            foreach (var i in képviselők.GroupBy(g => g.párt2).Select(g => new  { Párt = g.Key, arány = (double)g.Sum(x => x.voksok)/képviselők.Sum(x=>x.voksok)}))
                Console.WriteLine("\t{0}= {1:P2}", i.Párt, i.arány);

            Console.WriteLine("6. feldadat: Legtöbb szavazat:");
            foreach (var i in képviselők.Where(x => x.voksok==képviselők.Max(y=>y.voksok))) Console.WriteLine("\t{0} - {1}",i.név,i.párt3);

            Console.WriteLine("7. feldadat: kepviselok.txt");
            List<string> ki = new List<string>();
            foreach (var i in képviselők.GroupBy(x => x.kerület).Select(g => new { Kerület = g.Key, NyertesKépviselő = g.OrderByDescending(x => x.voksok).First().név, NyertesPárt = g.OrderByDescending(x => x.voksok).First().párt3 }).OrderBy(x=>x.Kerület))
                ki.Add(String.Format("Kerület:{0,-2} Győztes:{1,-25} Párt:{2}",i.Kerület,i.NyertesKépviselő,i.NyertesPárt));
            File.WriteAllLines("kepviselok.txt", ki);

            Console.ReadKey();
       }
    }
}
